/**==================================================================
CS:S League Of Legends Kill Announce Plugin
Copyright (C)2010-2012 Chamamyungsu All rights reserved.

이 프로그램은 자유 소프트웨어입니다: 당신은 이것을 자유 소프트웨어 재단이
발표한 GNU 일반 공중 사용허가서의 제3 버전이나 (선택에 따라) 그 이후 버전
의 조항 아래 재배포하거나 수정할 수 있습니다.

이 프로그램은 유용하게 쓰이리라는 희망 아래 배포되지만, 특정한 목적에 대한
프로그램의 적합성이나 상업성 여부에 대한 보증을 포함한 어떠한 형태의 보증
도 하지 않습니다. 세부 사항은 GNU 일반 공중 사용허가서를 참조하십시오.

당신은 이 프로그램과 함께 GNU 일반 공중 사용허가서를 받았을 것입니다.
만약 그렇지 않다면, < http://www.gnu.org/licences/ >를 보십시오.
==================================================================**/

#define PLUGIN_VERSION "1.4.0"
public Plugin:myinfo =
{
	name = "League Of Legends Kill Announce Plugin",
	author = "Chamamyungsu",
	description = "Made for Server, Thanks to RIOT Games, Javalia",
	version = PLUGIN_VERSION,
	url = "http://cafe.naver.com/sourcemulti"
};

#include <sourcemod>
#include <sdktools>
#include "stocklib"

#include "LOL/LOLsound"

#pragma semicolon 1

new KillAnnouncereserve[MAXPLAYERS*2][4]; //3번째 배열의 값은 특수한 상태를 나타냄. 1-처형 2-퍼스트블러드 3-제압 4-적처치 5-킬링스프리 6-마무리 4번째 배열의 값은 킬링 스프리와 제압시 연속킬, 연속킬 저장.
new bool:roundfirstblood = false;
new PlayerKillCount[MAXPLAYERS+1];
new PlayerConsecutivelyKill[MAXPLAYERS+1];
new Float:ConsecutivelyKillTimer[MAXPLAYERS+1];
new Float:AnnounceTimer = 0.0;
new aceisonetime[2] = 0;

new String:gamename[64];

new Handle:g_ConsecutivelyKillcontinuetime = INVALID_HANDLE;
new Handle:g_AnnounceCooltime = INVALID_HANDLE;
new Handle:g_Killingspree = INVALID_HANDLE;
new Handle:g_Rampage = INVALID_HANDLE;
new Handle:g_Unstoppable = INVALID_HANDLE;
new Handle:g_Dominating = INVALID_HANDLE;
new Handle:g_God_like = INVALID_HANDLE;
new Handle:g_Legendary = INVALID_HANDLE;

public OnPluginStart()
{
	CreateConVar("sm_LOLannounce_version", PLUGIN_VERSION, "Made By Chamamyungsu", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	g_ConsecutivelyKillcontinuetime = CreateConVar("LOLannounce_ConsecutivelyKillContinueTime", "5", "set the Kill Continue Time (seconds)");
	g_AnnounceCooltime = CreateConVar("LOLannounce_Announce_Cooltime", "2", "set the announce cooltime (seconds)");
	g_Killingspree = CreateConVar("LOLannounce_Killingspree", "4", "Kills streak required to trigger sound");
	g_Rampage = CreateConVar("LOLannounce_Rampage", "5", "Kills streak required to trigger sound");
	g_Unstoppable = CreateConVar("LOLannounce_Unstoppable", "7", "Kills streak required to trigger sound");
	g_Dominating = CreateConVar("LOLannounce_Dominating", "10", "Kills streak required to trigger sound");
	g_God_like = CreateConVar("LOLannounce_God_Like", "14", "Kills streak required to trigger sound");
	g_Legendary = CreateConVar("LOLannounce_Legendary", "19", "Kills streak required to trigger sound");
	AutoExecConfig();
	
	GetGameFolderName(gamename, sizeof(gamename));
	
	HookEvent("player_spawn", EventSpawn);
	HookEvent("player_death", EventDeath);
	if(StrEqual(gamename, "tf"))
		HookEvent("teamplay_round_start", roundstart_event);
	else if(StrEqual(gamename, "dod"))
		HookEvent("dod_round_start", roundstart_event);
	else if(StrEqual(gamename, "cstrike"))
		HookEvent("round_start", roundstart_event);
	LoadTranslations("LeagueOfLegendsKillAnnounce.phrases");
	CreateTimer(0.1, announce_timer, _, TIMER_REPEAT);
	AnnounceTimer = 0.0;
}

public OnMapStart()
{
	AutoExecConfig();
	prepatch_and_download_sounds();
	AnnounceTimer = 0.0;
}

public EventSpawn(Handle:Spawn_Event, const String:Spawn_Name[], bool:Spawn_Broadcast)
{
	new client = GetClientOfUserId(GetEventInt(Spawn_Event, "userid"));
	if(aceisonetime[GetClientTeam(client)-2] == 1)
		aceisonetime[0] = 0;
	if(aceisonetime[GetClientTeam(client)-2] == 1)
		aceisonetime[1] = 0;
}

public Action:roundstart_event(Handle:Event, const String:Name[], bool:Broadcast)
{
	roundfirstblood = false;
	aceisonetime[0] = 0;
	aceisonetime[1] = 0;
	for(new i=0; i<=MAXPLAYERS*2; i++)
	{
		if(KillAnnouncereserve[i][2] != 0)
		{
			KillAnnouncereserve[i][0] = 0;
			KillAnnouncereserve[i][1] = 0;
			KillAnnouncereserve[i][2] = 0;
			KillAnnouncereserve[i][3] = 0;
		}
		else
			break;
	}
}

public OnClientPutInServer(client)
{
	PlayerKillCount[client] = 0;
	PlayerConsecutivelyKill[client] = 0;
	ConsecutivelyKillTimer[client] = 0.0;
	for(new i=1; i<=MAXPLAYERS*2; i++)
	{
		if(KillAnnouncereserve[i][2] > 0)
		{
			if(KillAnnouncereserve[i][0] == client || KillAnnouncereserve[i][1] == client)
				KillAnnouncereserve[i][2] = 0;
		}
		else
			break;
	}
}

public Action:EventDeath(Handle:Spawn_Event, const String:Spawn_Name[], bool:Spawn_Broadcast)
{
	new client = GetClientOfUserId(GetEventInt(Spawn_Event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(Spawn_Event, "attacker"));

	if(client == 0 || client > MaxClients || attacker == 0 || attacker > MaxClients)
		return Plugin_Continue;

	new Float:now = GetEngineTime();
	if(ConsecutivelyKillTimer[attacker] <= now)
		PlayerConsecutivelyKill[attacker] = 0;
	ConsecutivelyKillTimer[attacker] = GetEngineTime() + GetConVarInt(g_ConsecutivelyKillcontinuetime);
	PlayerConsecutivelyKill[attacker] += 1;
	PlayerKillCount[attacker] += 1;
	
	//Event Check
	if(client == attacker)
		announce_reserve(attacker, client, 1, 0);
	else if(roundfirstblood == false && attacker > 0)
	{
		roundfirstblood = true;
		announce_reserve(attacker, client, 2, 0);
		if(PlayerKillCount[client] >= GetConVarInt(g_Killingspree))
			announce_reserve(attacker, client, 3, PlayerConsecutivelyKill[attacker]);
	}
	else if(PlayerKillCount[client] >= GetConVarInt(g_Killingspree))
		announce_reserve(attacker, client, 3, PlayerConsecutivelyKill[attacker]);
	else if(PlayerKillCount[attacker] >= GetConVarInt(g_Killingspree))
	{
		if(PlayerConsecutivelyKill[attacker] >= 2)
			announce_reserve(attacker, client, 4, PlayerConsecutivelyKill[attacker]);
		else if(PlayerKillCount[attacker] == GetConVarInt(g_Killingspree) || PlayerKillCount[attacker] == GetConVarInt(g_Rampage) || PlayerKillCount[attacker] == GetConVarInt(g_Unstoppable) || PlayerKillCount[attacker] == GetConVarInt(g_Dominating) || PlayerKillCount[attacker] == GetConVarInt(g_God_like) || PlayerKillCount[attacker] == GetConVarInt(g_Legendary))
			announce_reserve(attacker, client, 5, PlayerKillCount[attacker]);
		else
			announce_reserve(attacker, client, 4, PlayerConsecutivelyKill[attacker]);
	}
	else
		announce_reserve(attacker, client, 4, PlayerConsecutivelyKill[attacker]);
	if(AnnounceTimer == 0.0)
		AnnounceTimer = GetEngineTime();
	PlayerKillCount[client] = 0;
	return Plugin_Continue;
}

acecheckevent(attacker, client)
{
	if(aceisonetime[GetClientTeam(client)-2] == 0)
	{
		new acecheck=0;
		for(new i=1; i<=MaxClients; i++)
		{
			if(isClientConnectedIngameAlive(i) && GetClientTeam(client) == GetClientTeam(i))
			{
				acecheck = 1;
				break;
			}
		}
		if(acecheck == 0)
		{
			aceisonetime[GetClientTeam(client)-2] = 1;
			announce_reserve(attacker, client, 6, 0);
		}
	}
}

public Action:announce_timer(Handle:timer)
{
	new Float:now = GetEngineTime();
	if(AnnounceTimer <= now)
	{
		if(KillAnnouncereserve[0][2] > 0)
		{
			for(new i=1; i<=MaxClients; i++)
			{
				if(isClientConnectedIngame(i) && isClientConnectedIngame(KillAnnouncereserve[0][0]) && isClientConnectedIngame(KillAnnouncereserve[0][1]))
				{
					if(isClientConnectedIngame(i))
					{
						decl String:attackername[64], String:clientname[64];
						GetClientName(KillAnnouncereserve[0][0], attackername, 64);
						if(KillAnnouncereserve[0][1] > 0)
							GetClientName(KillAnnouncereserve[0][1], clientname, 64);
						new teamtemp = GetClientTeam(KillAnnouncereserve[0][0]);
						if(KillAnnouncereserve[0][2] == 1)
						{
							playsoundfromclient(i, SOUNDEXECUTED);
							PrintCenterText(i, "%t", "{1} has executed!", attackername);
						}
						if(KillAnnouncereserve[0][2] == 2)
						{
							playsoundfromclient(i, SOUNDFIRSTBLOOD);
							PrintToChat(i, "\x05%t", "{1} has drawn first blood!", attackername);
							PrintCenterText(i, "%t", "centerfirstblood", i);
						}
						if(KillAnnouncereserve[0][2] == 3)
						{
							playsoundfromclient(i, SOUNDSHUTDOWN);
							if(KillAnnouncereserve[0][3] == 1)
								PrintToChat(i, "\x05%t", "{1} has ended {2}'s killing spree", attackername, clientname);
							if(KillAnnouncereserve[0][3] == 2)
								PrintToChat(i, "\x05%t", "{1} has ended {2}'s killing spree for a double kill!", attackername, clientname);
							if(KillAnnouncereserve[0][3] == 3)
								PrintToChat(i, "\x05%t", "{1} has ended {2}'s killing spree for a triple kill!", attackername, clientname);
							if(KillAnnouncereserve[0][3] == 4)
								PrintToChat(i, "\x05%t", "{1} has ended {2}'s killing spree for a quadra kill!", attackername, clientname);
							if(KillAnnouncereserve[0][3] >= 5)
								PrintToChat(i, "\x05%t", "{1} has ended {2}'s killing spree for a penta kill!", attackername, clientname);
							PrintCenterText(i, "%t", "centershutdown", i);
						}
						if(KillAnnouncereserve[0][2] == 4)
						{
							if(KillAnnouncereserve[0][3] == 1 && aceisonetime[GetClientTeam(KillAnnouncereserve[0][1])-2] == 0)
							{
								new acecheck=0;
								for(new ii=1; ii<=MaxClients; ii++)
								{
									if(isClientConnectedIngameAlive(ii) && GetClientTeam(KillAnnouncereserve[0][1]) == GetClientTeam(ii))
									{
										acecheck = 1;
										break;
									}
								}
								if(acecheck == 0)
								{
									aceisonetime[GetClientTeam(KillAnnouncereserve[0][1])-2] = 1;
									announce_reserve(KillAnnouncereserve[0][0], KillAnnouncereserve[0][1], 6, 0);
								}
								else
								{
									PrintCenterText(i, "%t", "{1} has slain {2}!", attackername, clientname);
									if(teamtemp == GetClientTeam(i))
									{
										if(i == KillAnnouncereserve[0][0])
											playsoundfromclient(i, GetRandomInt(9, 11));
										else
											playsoundfromclient(i, GetRandomInt(3, 5));
									}
									else
									{
										if(i == KillAnnouncereserve[0][1])
											playsoundfromclient(i, GetRandomInt(6, 7));
										else
											playsoundfromclient(i, GetRandomInt(1, 2));
									}
								}
							}
							if(KillAnnouncereserve[0][3] == 2)
							{
								PrintToChat(i, "\x05%t", "{1} has slain {2} for a double kill!", attackername, clientname);
								PrintCenterText(i, "%t", "centerdoublekill", i);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(16, 18));
								else
									playsoundfromclient(i, GetRandomInt(14, 15));
							}
							if(KillAnnouncereserve[0][3] == 3)
							{
								PrintToChat(i, "\x05%t", "{1} has slain {2} for a triple kill!", attackername, clientname);
								PrintCenterText(i, "%t", "centertriplekill", i);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(21, 22));
								else
									playsoundfromclient(i, GetRandomInt(19, 20));
							}
							if(KillAnnouncereserve[0][3] == 4)
							{
								PrintToChat(i, "\x05%t", "{1} has slain {2} for a quadra kill!", attackername, clientname);
								PrintCenterText(i, "%t", "centerquadrakill", i);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(24, 25));
								else
									playsoundfromclient(i, SOUNDENEMYQUADRAKILL);
							}
							if(KillAnnouncereserve[0][3] >= 5)
							{
								PrintToChat(i, "\x05%t", "{1} has slain {2} for a penta kill!", attackername, clientname);
								PrintCenterText(i, "%t", "centerpentakill", i);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(28, 29));
								else
									playsoundfromclient(i, GetRandomInt(26, 27));
							}
						}
						else if(KillAnnouncereserve[0][2] == 5)
						{
							if(KillAnnouncereserve[0][3] == GetConVarInt(g_Killingspree))
							{
								PrintToChat(i, "\x05%t", "{1} is on a killing spree!", attackername);
								PrintCenterText(i, "%t", "{1} is on a killing spree!", attackername);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(33, 34));
								else
									playsoundfromclient(i, GetRandomInt(31, 32));
							}
							else if(KillAnnouncereserve[0][3] == GetConVarInt(g_Rampage))
							{
								PrintToChat(i, "\x05%t", "{1} is on a rampage!", attackername);
								PrintCenterText(i, "%t", "{1} is on a rampage!", attackername);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(36, 37));
								else
									playsoundfromclient(i, SOUNDENEMYRAMPAGE);
							}
							else if(KillAnnouncereserve[0][3] == GetConVarInt(g_Unstoppable))
							{
								PrintToChat(i, "\x05%t", "{1} is unstoppable!", attackername);
								PrintCenterText(i, "%t", "{1} is unstoppable!", attackername);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, SOUNDUNSTOPPABLE);
								else
									playsoundfromclient(i, GetRandomInt(38, 39));
							}
							else if(KillAnnouncereserve[0][3] == GetConVarInt(g_Dominating))
							{
								PrintToChat(i, "\x05%t", "{1} is dominating!", attackername);
								PrintCenterText(i, "%t", "{1} is dominating!", attackername);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, SOUNDDOMINATING);
								else
									playsoundfromclient(i, SOUNDENEMYDOMINATING);
							}
							else if(KillAnnouncereserve[0][3] == GetConVarInt(g_God_like))
							{
								PrintToChat(i, "\x05%t", "{1} is god like!", attackername);
								PrintCenterText(i, "%t", "{1} is god like!", attackername);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(45, 46));
								else
									playsoundfromclient(i, GetRandomInt(43, 44));
							}
							else if(KillAnnouncereserve[0][3] == GetConVarInt(g_Legendary))
							{
								PrintToChat(i, "\x05%t", "{1} is legendary!", attackername);
								PrintCenterText(i, "%t", "{1} is legendary!", attackername);
								if(teamtemp == GetClientTeam(i))
									playsoundfromclient(i, GetRandomInt(49, 51));
								else
									playsoundfromclient(i, GetRandomInt(47, 48));
							}
						}
						else if(KillAnnouncereserve[0][2] == 6)
						{
							playsoundfromclient(i, GetRandomInt(12, 13));
							PrintCenterText(i, "%t", "ACE!", i);
							if(teamtemp == GetClientTeam(i))
								PrintToChat(i, "\x05%t", "ALLY ACE!", i);
							else
								PrintToChat(i, "\x05%t", "ENEMY ACE!", i);
						}
						if(KillAnnouncereserve[0][2] != 4 || (KillAnnouncereserve[0][2] == 4 && KillAnnouncereserve[0][3] > 1))
							acecheckevent(KillAnnouncereserve[0][0], KillAnnouncereserve[0][1]);
					}
				}
			}
			for(new i=1; i<=MAXPLAYERS*2; i++)
			{
				if(KillAnnouncereserve[i][2] > 0)
				{
					for(new ii=0; ii<=3; ii++)
						KillAnnouncereserve[i-1][ii] = KillAnnouncereserve[i][ii];
				}
				else
				{
					for(new ii=0; ii<=3; ii++)
						KillAnnouncereserve[i-1][ii] = 0;
					break;
				}
			}
			AnnounceTimer = GetEngineTime() + GetConVarInt(g_AnnounceCooltime);
		}
	}
}

public announce_reserve(attacker, client, num, kscount)
{
	for(new i=0; i<=MAXPLAYERS*2; i++)
	{
		if(KillAnnouncereserve[i][0] == attacker && KillAnnouncereserve[i][2] == 4 && num == 4)
		{
			if(KillAnnouncereserve[i][3] < kscount)
			{
				KillAnnouncereserve[i][1] = client;
				KillAnnouncereserve[i][3] = kscount;
				break;
			}
		}
		else if(KillAnnouncereserve[i][2] == 0)
		{
			KillAnnouncereserve[i][0] = attacker;
			KillAnnouncereserve[i][1] = client;
			KillAnnouncereserve[i][2] = num;
			KillAnnouncereserve[i][3] = kscount;
			break;
		}
	}
}